function S = signm(Z,scale);
n = size(Z,1);
ZZ = zeros(n);
iter = 0;
err = norm(Z-ZZ,'fro')/norm(Z,'fro');
d(1) = 1;
if nargin < 2, scale = 1, end
if scale == 1,
    disp('no scaling')
elseif scale == 2,
    disp('determinantel scaling')
elseif scale == 3,
    disp('optimal norm scaling')
elseif scale == 4,
    disp('Frobenius norm scaling')
else
    error('1 <= scale <= 4 required')
end
while (err > 10*n*eps) & (iter < 50),
    iter = iter+1;
    ZZ = Z;
    [L,U,P] = lu(Z);
    Y = L\P;
    Y = U\Y;
    if scale == 2,  
        c = abs(diag(U));
        c = c.^(1/n);
        c = prod(c);
    elseif scale == 3,
        c = sqrt(norm(Z)/norm(Y));
    elseif scale == 4,
        c = sqrt(norm(Z,'fro')/norm(Y,'fro'));
    else
        c = 1;
    end
    Z  = (Z/c + c*Y)/2;
    err = norm(Z-ZZ,'fro')/norm(Z,'fro');    
    disp(sprintf('  relerr(%i) = %0.5g', iter, err))
end
S = Z;